<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="订单编号" prop="orderNo">
        <el-input v-model="formData.orderNo" placeholder="请输入订单编号" />
      </el-form-item>
      <el-form-item label="会员ID" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入会员ID" />
      </el-form-item>
      <el-form-item label="数量" prop="quantity">
        <el-input v-model="formData.quantity" placeholder="请输入数量" />
      </el-form-item>
      <el-form-item label="商品ID" prop="productId">
        <el-input v-model="formData.productId" placeholder="请输入商品ID" />
      </el-form-item>
      <el-form-item label="单价" prop="unitPrice">
        <el-input v-model="formData.unitPrice" placeholder="请输入单价" />
      </el-form-item>
      <el-form-item label="总价" prop="totalPrice">
        <el-input v-model="formData.totalPrice" placeholder="请输入总价" />
      </el-form-item>
      <el-form-item label="是否连单" prop="combination">
        <el-input v-model="formData.combination" placeholder="请输入是否连单" />
      </el-form-item>
      <el-form-item label="任务序号" prop="taskSequence">
        <el-input v-model="formData.taskSequence" placeholder="请输入任务序号" />
      </el-form-item>
      <el-form-item label="任务状态" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio
            v-for="dict in getIntDictOptions(DICT_TYPE.$dictType.toUpperCase())"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="下单时间" prop="orderTime">
        <el-date-picker
          v-model="formData.orderTime"
          type="date"
          value-format="x"
          placeholder="选择下单时间"
        />
      </el-form-item>
      <el-form-item label="完成时间" prop="submitTime">
        <el-date-picker
          v-model="formData.submitTime"
          type="date"
          value-format="x"
          placeholder="选择完成时间"
        />
      </el-form-item>
      <el-form-item label="评价星级" prop="starRating">
        <el-input v-model="formData.starRating" placeholder="请输入评价星级" />
      </el-form-item>
      <el-form-item label="描述">
        <Editor v-model="formData.description" height="150px" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { DICT_TYPE, getIntDictOptions } from '@/utils/dict'
import * as TaskRecordApi from '@/api/member/taskRecord'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  orderNo: undefined,
  userId: undefined,
  quantity: undefined,
  productId: undefined,
  unitPrice: undefined,
  totalPrice: undefined,
  combination: undefined,
  taskSequence: undefined,
  status: undefined,
  orderTime: undefined,
  submitTime: undefined,
  starRating: undefined,
  description: undefined
})
const formRules = reactive({
  userId: [{ required: true, message: '会员ID不能为空', trigger: 'blur' }],
  productId: [{ required: true, message: '商品ID不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await TaskRecordApi.getTaskRecord(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as TaskRecordApi.TaskRecordVO
    if (formType.value === 'create') {
      await TaskRecordApi.createTaskRecord(data)
      message.success(t('common.createSuccess'))
    } else {
      await TaskRecordApi.updateTaskRecord(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    orderNo: undefined,
    userId: undefined,
    quantity: undefined,
    productId: undefined,
    unitPrice: undefined,
    totalPrice: undefined,
    combination: undefined,
    taskSequence: undefined,
    status: undefined,
    orderTime: undefined,
    submitTime: undefined,
    starRating: undefined,
    description: undefined
  }
  formRef.value?.resetFields()
}
</script>
